%macro sasdrugdev_getobjects(sddpath=, dsname=work._getobjects_);
  %global _sddRC_ _sddMsg_;
  %let _sddRC_=%str(-1);
  %let _sddMsg_=;
  %let _sddRowCount_=%str(-1);
  data &dsname(label="Created by sasdrugdev_getobjects" keep=name sizeString owner type dateTimeString modifiedby isContainer);
    attrib returnCode     length=8;
    attrib message        length=$200;
    attrib rowCount       length=8;
    attrib name           length=$200 label="Name";
    attrib sizeString     length=$200 label="Size";
    attrib type           length=$40  label="Type";
    attrib owner          length=$40 label="Owner";
    attrib dateTimeString length=$25 label="Last Modified Date and Time (GMT)";
    attrib modifiedby     length=$40 label="ModifiedBy";
    attrib isContainer    length=8    label="Flag indicating if the object is a container" format=best.;

    declare javaobj cmd("com/sas/drugdev/remote/sasmacro/command/GetObjectsCommand", "%bquote(&sddpath)");
    declare javaobj results("com/sas/drugdev/remote/sasmacro/results/GetNodesResult");
    cmd.callVoidMethod("execute", results);
    results.callIntMethod("getReturnCode", returnCode);
    results.callStringMethod("getReturnMessage", message);
    if (returnCode=0) then do;
      results.callIntMethod("getObjectCount", rowCount);
      do row=0 to rowCount - 1;
        results.callStringMethod("getName", row, name);
        results.callStringMethod("getSizeString", row, sizeString);        
        results.callLongMethod("getIsContainer", row, isContainer);
        results.callStringMethod("getType", row, type);
        results.callStringMethod("getOwner", row, owner);
        results.callStringMethod("getLastModifiedDate", row, dateTimeString);
        results.callStringMethod("getOwner", row, owner);
        results.callStringMethod("getLastModifiedBy", row, modifiedby);
        output;
      end;
      put "NOTE: SAS Drug Development Macro: sasdrugdev_getobjects 3.4";
      put "NOTE: SAS Drug Development Macro: * returned a list of objects in %bquote(&sddpath)";
      if (rowCount=0) then
          put "NOTE: SAS Drug Development Macro: * No objects were found.";
      put "NOTE: SAS Drug Development Macro: * " rowCount " records written to dataset &dsname";
    end;
    else do;
      put "ERROR: SAS Drug Development Macro: sasdrugdev_getobjects 3.4";
      put "ERROR: SAS Drug Development Macro: * Return Code: " returnCode;
      put "ERROR: SAS Drug Development Macro: * Tried to list the objects in %bquote(&sddpath)";
      put "ERROR: SAS Drug Development Macro: * " message;
    end;
    call symputx("_sddRC_", returnCode);
    call symputx("_sddMsg_", message);
    call symputx("_sddRowCount_", rowCount);
  run;
  %if &_sddRowCount_ > 0 %then %do;
     data temp;
       set &dsname;
       upname=upcase(name);
       upname=translate(upname,'1','_');
     run;
     proc sort data=temp;
       by upname;
     run;
     data &dsname;
     set temp(drop=upname);
     run;
     proc datasets library=work;
        delete temp;
     run;
  %end;
%mend sasdrugdev_getobjects;
